"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EscrwWorldsActionMongoSource = void 0;
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
class EscrwWorldsActionMongoSource extends aw_storage_mongodb_1.MongoCollectionSource {
    constructor(mongoSource) {
        super(mongoSource, 'escrw.worlds_actions', {
            indexes: [
                { key: { block_num: 1 }, background: true },
                { key: { 'action.name': 1 }, background: true },
                { key: { 'action.account': 1, 'action.name': 1 }, background: true },
                {
                    key: {
                        action_hash: 1,
                        block_num: 1,
                        block_timestamp: 1,
                        global_sequence: 1,
                        recv_sequence: 1,
                        trx_id: 1,
                    },
                    unique: true,
                    background: true,
                },
            ],
        });
    }
}
exports.EscrwWorldsActionMongoSource = EscrwWorldsActionMongoSource;
