"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApproveRawMapper = exports.ApproveMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class ApproveMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('key', {
            key: 'key',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('approver', {
            key: 'approver',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { key, approver, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Approve.create(key || '', approver || '', dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.ApproveMongoMapper = ApproveMongoMapper;
class ApproveRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { key, approver, dac_id, ...rest } = rawModel;
        return entities_1.Approve.create(key || '', approver || '', dac_id || '', undefined, rest);
    }
}
exports.ApproveRawMapper = ApproveRawMapper;
