"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InitRawMapper = exports.InitMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class InitMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('sender', {
            key: 'sender',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('receiver', {
            key: 'receiver',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('arb', {
            key: 'arb',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('expires', {
            key: 'expires',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('memo', {
            key: 'memo',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('extReference', {
            key: 'ext_reference',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { sender, receiver, arb, expires, memo, ext_reference, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Init.create(sender || '', receiver || '', arb || '', expires || new Date(0), memo || '', ext_reference || '', dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.InitMongoMapper = InitMongoMapper;
class InitRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { sender, receiver, arb, expires, memo, ext_reference, dac_id, ...rest } = rawModel;
        return entities_1.Init.create(sender || '', receiver || '', arb || '', expires || new Date(0), memo || '', ext_reference || '', dac_id || '', undefined, rest);
    }
}
exports.InitRawMapper = InitRawMapper;
